// ---------------------------------------------------------------------------
// crouch.cs -- Version 1.7 -- October 28, 2000
// by Lorne Laliberte (writer@planetstarsiege.com)
//
// Toggle crouch mode on/off without having to hold the crouch key down
//
// http://www.writerscripts.com
// ---------------------------------------------------------------------------

include("writer\\version.cs");
version("writer\\crouch.cs", "1.7", "Lorne Laliberte", "Oct 28, 2000");

include("writer\\event.cs");
include("writer\\save.cs");
include("writer\\tap.cs");

// ---------------------------------------------------------------------------
// DEFAULT SETTINGS:
//
// Edit these if you're running this script for the first time
// All subsequent settings must be done in the config\wp_crouch.cs file

    // Toggle crouch mode on by tapping the crouch key
    $Crouch::KeyTapMode = "false";

    // Length of time within which a key must be pressed and released
    // to be recognized as a key "tap"
    $Crouch::KeyTapTime = "0.100";

    // Toggle crouch mode on/off with each key press
    $Crouch::KeyPressMode = "true";

    // Toggle crouch
    //bind(keyboard0, make, "r", to, "CrouchPressed();");
    //bind(keyboard0, break, "r", to, "CrouchReleased();");

// ---------------------------------------------------------------------------

WriterPrefs::load("crouch");

function CrouchPressed()
{
    Event::Trigger(eventCrouchPressed);

    if( !Event::Returned(eventCrouchPressed, mute) )
    {
        postAction(2048, IDACTION_CROUCH, -0);
        Event::Trigger(eventCrouching);
    }
}


function CrouchReleased()
{
    Event::Trigger(eventCrouchReleased);

    if( !Event::Returned(eventCrouchReleased, mute) )
    {
        postAction(2048, IDACTION_STAND, -0);
        Event::Trigger(eventStanding);
    }
}


function onCrouchPressed()
{
    if($Crouching)
    {
        postAction(2048, IDACTION_STAND, -0);
        $Crouching = false;
        Event::Trigger(eventStanding);
        return mute;
    }

    $Crouching = true;

    if($Crouch::KeyTapMode)
        tap(crouch, $Crouch::KeyTapTime);

    return;
}


function onCrouchReleased()
{
    if(wasTapped(crouch) || $Crouch::KeyPressMode)
        return mute;

    $Crouching = false;
    return;
}


function Crouch::onYoudied()
{
    if($Crouching)
    {
        postAction(2048, IDACTION_STAND, -0);
        $Crouching = false;
        $Crouching = false;
    }
    return;
}

function crouch::save()
{
    AddExportText("    // Toggle crouch mode on by tapping the crouch key");
    ExportSetting("    $Crouch::KeyTapMode", false);
    AddExportText("");
    AddExportText("    // Length of time within which a key must be pressed and released");
    AddExportText("    // to be recognized as a key \"tap\"");
    ExportSetting("    $Crouch::KeyTapTime", "0.100");
    AddExportText("");
    AddExportText("    // Toggle crouch mode on/off with each key press");
    ExportSetting("    $Crouch::KeyPressMode", true);
    AddExportText("");
    AddExportText("    // Toggle crouch");

    ExportBind("CrouchPressed();", "//bind(keyboard0, make, \"r\", TO, \"CrouchPressed();\");");
    ExportBind("CrouchReleased();", "//bind(keyboard0, break, \"r\", TO, \"CrouchReleased();\");");
}

WriterPrefs::save("crouch");

function crouch::init()
{
    needs("writer\\crouch.cs", "writer\\event.cs 2.7",
                               "writer\\save.cs 2.3",
                               "writer\\tap.cs 1.2");

    if($Crouch::KeyTapMode || $Crouch::KeyPressMode)
    {
        Event::Attach(eventCrouchPressed, "onCrouchPressed();");
        Event::Attach(eventCrouchReleased, "onCrouchReleased();");
        Event::Attach(eventYouDied, "Crouch::onYouDied();");
    }
}
Event::Attach(writerInit, "crouch::init();");

if(!$UsingWriterLoader) crouch::init();
